private import obj;
private import game;
private import mygl;
private import common;
private import enemy;

abstract class DrawObj : Obj {
    override void move() {}
}

class FieldDraw : DrawObj {
    override void draw() {
        with (Game.obj()) {
            glDisable(GL_TEXTURE_2D);

            glColor4f(1, 1, 1, 0.4);
            float x1, y1, x2, y2;
            x1 = 0;
            y1 = 0;
            x2 = fieldWidth;
            y2 = fieldHeight;
            convPos(x1, y1);
            convPos(x2, y2);

            float rs() { return rnd(6.0)-3.0; }

            if (x1 > 0) {
                glBegin(GL_LINES);
                for (int i = 0; i < 4; i++) {
                    glVertex2f(x1+rs, y1);
                    glVertex2f(x1+rs, y2);
                }
                glEnd();
            }
            else if (x2 < screenWidth) {
                glBegin(GL_LINES);
                for (int i = 0; i < 4; i++) {
                    glVertex2f(x2+rs, y1);
                    glVertex2f(x2+rs, y2);
                }
                glEnd();
            }
            if (y1 > 0) {
                glBegin(GL_LINES);
                for (int i = 0; i < 4; i++) {
                    glVertex2f(x1, y1+rs);
                    glVertex2f(x2, y1+rs);
                }
                glEnd();
            }
            else if (y2 < screenHeight) {
                glBegin(GL_LINES);
                for (int i = 0; i < 4; i++) {
                    glVertex2f(x1, y2+rs);
                    glVertex2f(x2, y2+rs);
                }
                glEnd();
            }
        }
    }
}

