import SDL_pad;

private import mymath;

void function() reprecNext;
int function() reprecAxis;
int function() reprecAButton;
int function() reprecBButton;
int function() reprecAButtonPushed;

void recMode() {
    reprecNext = &recNext;
    reprecAxis = &recAxis;
    reprecAButton = &recAButton;
    reprecBButton = &recBButton;
    reprecAButtonPushed = &recAButtonPushed;
    reprecBuf.length = 0;
    reprecGenRand.init();
}

void repMode() {
    reprecNext = &repNext;
    reprecAxis = &repAxis;
    reprecAButton = &repAButton;
    reprecBButton = &repBButton;
    reprecAButtonPushed = &repAButtonPushed;
    reprecBuf.length = 0;
    repIte = -1;
}

char[] reprecBuf;

private:

int repIte;

void recNext() {
    char c = recAxis();
    c |= (recAButton() << 4);
    c |= (recBButton() << 5);
    c |= (recAButtonPushed() << 6);
    reprecBuf ~= c;
}

int recAxis() {
    return Pad_GetAxis(0);
}

int recAButton() {
    return Pad_GetButtonPressed(PAD_A_BUTTON);
}

int recBButton() {
    return Pad_GetButtonPressed(PAD_B_BUTTON);
}

int recAButtonPushed() {
    return Pad_GetButtonPushed(PAD_A_BUTTON);
}

void repNext() {
    repIte++;
    if (repIte >= reprecBuf.length) {
        repIte--;
    }
}

int repAxis() {
    return reprecBuf[repIte] & 15;
}

int repAButton() {
    return (reprecBuf[repIte] & 16) == 16;
}

int repBButton() {
    return (reprecBuf[repIte] & 32) == 32;
}

int repAButtonPushed() {
    return (reprecBuf[repIte] & 64) == 64;
}
