private import mygl;
private import game;
private import drawobjs;
private import sino;

class GameViewport : DrawObj {
    override void draw() {
        with (Game.obj()) {
//            float r = (float)screenWidth / 640;
//            glViewport(170, 25, gameWidth*r, gameHeight*r);
            glViewport(gameScreenX, gameScreenY,
                       gameScreenWidth+gameScreenX,
                       gameScreenHeight+gameScreenY);

            glMatrixMode(GL_PROJECTION);
            glLoadIdentity();

/*
  glOrtho(gameScreenX,
  gameWidth+gameScreenX,
  gameHeight+gameScreenY,
  gameScreenY,
  -1000, 1000);
*/

            glFrustum(gameScreenX / 10,
                      (gameWidth+gameScreenX) / 10,
                      (gameHeight+gameScreenY) / 10,
                      gameScreenY / 10,
                      0.1, 2.0);


/*
            glOrtho(gameScreenX,
                    gameWidth+gameScreenX,
                    gameHeight+gameScreenY,
                    gameScreenY,
                    -1, 1);
*/
            glMatrixMode(GL_MODELVIEW);
            glLoadIdentity();

            glTranslatef(0, 0, -1);
        }
    }
}

class SysViewport : DrawObj {
    this() {
        screenWidth = Sino.obj.screenWidth;
        screenHeight = Sino.obj.screenHeight;
    }
    override void draw() {
        glViewport(0, 0, screenWidth, screenHeight);

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();

        gluOrtho2D(0, 640, 480, 0);

        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
    }

private:
    int screenWidth, screenHeight;
}
