private import std.math;

private import opengl;

private import mygl;
private import obj;
private import common;

class Charactor : Obj {
public:
    this() {
        turn_ = 0;
        alive_ = true;
        alpha_ = 1;
        sx_ = sy_ = 0;
    }
    ~this() {
    }

    override void move() {
        x_ += sx_;
        y_ += sy_;
        turn_++;
    }

    float x() { return x_; }
    float y() { return y_; }

    float sx() { return sx_; }
    float sy() { return sy_; }

    void x(float x) {
        x_ = x;
    }
    void y(float y) {
        y_ = y;
    }
    void sx(float sx) {
        sx_ = sx;
    }
    void sy(float sy) {
        sy_ = sy;
    }

    float a() { return a_; }
    float s() { return s_; }
    void a(float a0) { a_ = a0; }
    void s(float s0) { s_ = s0; }

    bit alive() { return alive_; }
    void die() { alive_ = false; }

    int turn() { return turn_; }

    void wait(int t) {}

    void setRGB(float r, float g, float b) {
        r_ = r;
        g_ = g;
        b_ = b;
    }

    float r() { return r_; }
    float g() { return g_; }
    float b() { return b_; }

    override void draw() {
        // dummy impl

        static int[] ints = [ -139, -77, -7, 23, 103, 207 ];
        static int[] ints2 = [ -139, -77, /*-7, 23,*/ 103, 207 ];

        glPushMatrix();

        glTranslatef(x_, y_, 0);
//            glRotatef(a_, 0, 0, 1);
        glRotatef(-rtod(a_), 0, 0, 1);
        glRotatef(-turn*4, 0, 1, 0);

        glBegin(GL_TRIANGLE_FAN);
        glColor4f(1, 1, 1, 0.9);
        glVertex3f(2, 10, 0);
        glVertex3f(-3, -5, 0);
        glVertex3f(3, -5, 0);
        glEnd();

        glBegin(GL_QUADS);
        glColor4f(0.7, 0.7, 0.5, 0.9);
        glVertex3f(2, -15, 0);
        glVertex3f(-2, -15, 0);
        glVertex3f(-2, -5, 0);
        glVertex3f(2, -5, 0);
        glEnd();

        glPopMatrix();
    }

protected:
    float x_, y_;
    float sx_, sy_;
    float a_, s_;
    int turn_;
    float r_, g_, b_, alpha_;
    bool alive_;
    int size_;

}

